//http://digistump.com/package_digistump_index.json
// use DigiSpark (default -16.5mhz) 
// Boot loader runs for 60 seconds and then reboot to flash LEDs
//
/*
 * Auto Keyboard with LDR to detect bright to dark and dark to bright transition.
 * 
 * Link between PO and P2
 * LDR between P0 and GND
 * 
 * PO--P2--[LDR]--GND
 *
 * 
 * Use Stickstion to detect change of light level
 * 
 * sensor = DARK if moved into dark
 * sensor = BRIGHT if moves into light.
 * 
 */
/* 
// C:\Users\doug\AppData\Local\Arduino15\packages\digistump\hardware\avr\1.6.7\libraries
*/

/*
 * I can put an LDR and look for the Black Screen
 * I really need signals from xAWS to say what state I am in.
 * 
 * 
 */

//187 BB Keypad Backspace

#include "DigiKeyboard.h"
#define KEY_ARROW_RIGHT 0x4F
#define KEY_TAB 0x2B
#define KEY_BACKSPACE 0xBB 

//SENSOR
#define DARK   1
#define BRIGHT 0


  int analogPin = 1;     // potentiometer wiper (middle terminal) connected to analog pin 3                       // outside leads to ground and +5V
  int val = 0;           // variable to store the value read
  int lastVal = 0;           // variable to store the value read
  int sensor = BRIGHT;

/*
 * p0 LED
 * p1
 * p2
 * p3 USB +  1.5K pullup
 * p4 USB -  PWM
 * p5 reset
 * 
 * PINS
 1 - PB0 / MOSI
 2 - PB1 / MISO
 3 - PB2 / SCK / AD1
 4 - PB3 / AD3 (Reserved for USB)
 5 - PB4 / AD2 (Reserved for USB)
 6 - PB5 / RES (Reset may be disabled on some boards)
 * 
 * 
 */

/*
void sendText(){
  DigiKeyboard.println( '0'+digitalRead(0) );
  DigiKeyboard.println( '0'+digitalRead(1) );
  DigiKeyboard.println( '0'+digitalRead(2) );
  DigiKeyboard.println( '0'+digitalRead(3) );

  
  DigiKeyboard.println("The quick brown fox jumped over the Lazy dog GA");
  DigiKeyboard.delay(random( 100, 750) );
  
  // It's better to use DigiKeyboard.delay() over the regular Arduino delay()
  // if doing keyboard stuff because it keeps talking to the computer to make
  // sure the computer knows the keyboard is alive and connected
  //DigiKeyboard.delay(5000);
  DigiKeyboard.delay(random( 100, 750) );
  digitalWrite(1,LOW);

  DigiKeyboard.println("some random characters T q B # !£$ ^ 7 * 9 0 )) GA");
  DigiKeyboard.delay(random( 100, 750) );
  
  DigiKeyboard.println("! \" £ $ % ^ & * ( ) _ +  GA");
  DigiKeyboard.delay(random( 100, 750) );
  
  DigiKeyboard.println("1 2 3 4 5 6 7 8 9 0 - =   GA");
  DigiKeyboard.delay(random( 100, 750) );
  
  DigiKeyboard.println("Q W E R T Y U I O P { }  GA");
  DigiKeyboard.delay(random( 100, 750) );
  DigiKeyboard.println("a s d f g h j k l : @  GA");
  DigiKeyboard.delay(random( 100, 750) );
  DigiKeyboard.println("| \\ z X c V b N m < , > . ? / GA");
  DigiKeyboard.delay(random( 100, 750) );
  
}
*/

/*
 * 
 * Use Sticktion instead of dV/Dt
 * 
 * only move if change big enough
 */
 
 void pollLDRts(){
  val = analogRead(analogPin);    // read the input pin
  pinMode(1, OUTPUT );

  // bright < 150
  // Dark > 300

  // LDR gone low res
  if (  val  < 180 ){
    lastVal = val;
    sensor = BRIGHT;
    digitalWrite(1,HIGH );
    return;
  }
  
  if  ( val  > 300 ){
    lastVal = val;
    sensor = DARK;
    digitalWrite(1,LOW );
    return;
  }
   
  if ( ( val - lastVal ) > 10 ){
    lastVal = val;
    sensor = DARK;
    digitalWrite(1,LOW );
  }

  // LDR gone low res
  if ( ( val - lastVal ) < -10 ){
    lastVal = val;
    sensor = BRIGHT;
    digitalWrite(1,HIGH );
  }
}

void typeAtoD(){
  DigiKeyboard.print( " AtoD:" );
  DigiKeyboard.print( val );
  DigiKeyboard.print( " : " );
  DigiKeyboard.print( lastVal );
  DigiKeyboard.print( " dV:" );
  DigiKeyboard.print( val-lastVal );
  DigiKeyboard.print( " L: " );
  DigiKeyboard.println( sensor );
}


void xaws999relinquish(){
  
  /*
 * xAWS 999 sequence to relinquish
 * 
 * ALT-tab
 * ->
 * Alt-R
 * 
 */
//    digitalWrite(1,HIGH);
    DigiKeyboard.delay(1000);
    DigiKeyboard.sendKeyStroke( KEY_TAB, MOD_ALT_LEFT );
    DigiKeyboard.delay(random( 100, 750) );

    /*
     * Check if 
     */

    DigiKeyboard.sendKeyStroke( KEY_U, MOD_ALT_LEFT );
    DigiKeyboard.delay(random( 100, 750) );

    DigiKeyboard.sendKeyStroke( KEY_ARROW_RIGHT );
    DigiKeyboard.delay(random( 100, 750) );

    DigiKeyboard.sendKeyStroke( KEY_ARROW_RIGHT );
    DigiKeyboard.delay(random( 100, 750) );

    DigiKeyboard.sendKeyStroke( KEY_R );
    DigiKeyboard.delay(random( 100, 750) );
    digitalWrite(1,LOW);

}

void xaws999selectTO(){
  
 /*
 * xAWS 999 sequence to relinquish
 * 
 * ALT X  // cursor 
 * T      // To
 * KEY_BACKSPACE     // Backspace to delete number
 * digits
 * 
 */
/*
 * To select the To bo 
 */
  DigiKeyboard.delay( random( 550, 1000) );
  DigiKeyboard.sendKeyStroke( KEY_X, MOD_ALT_LEFT );
  DigiKeyboard.delay( random( 200, 550) );
  DigiKeyboard.print( "T");
  DigiKeyboard.sendKeyStroke( KEY_ARROW_RIGHT );
  DigiKeyboard.delay(random( 100, 750) );
  DigiKeyboard.sendKeyStroke( KEY_ARROW_RIGHT );
  DigiKeyboard.delay(random( 100, 750) );
}

void xaws999selectToBackspace(){

  // delete existing number.
  DigiKeyboard.delay( random( 200, 550) );
  DigiKeyboard.print( "\b\b\b\b\b");
  DigiKeyboard.delay( random( 200, 550) );
  DigiKeyboard.print( "\b\b\b\b\b");
  DigiKeyboard.delay( random( 200, 550) );
  DigiKeyboard.print( "\b\b\b\b\b");
  DigiKeyboard.delay( random( 200, 550) );
}

void xaws999extend(){  
 /*
 * xAWS 999 sequence to extend
 * 
 * F5   // 
 *      // wait ANS
 *        DigiKeyboard.delay( random( 100, 350) );
 * F5
 *
 */
  DigiKeyboard.sendKeyStroke( KEY_F5 );
  DigiKeyboard.delay( random( 1000, 2000) );
  DigiKeyboard.sendKeyStroke( KEY_F5 );
  DigiKeyboard.delay( random( 100, 750) );
  // If call Answered, then 999 operator returns to READY screen
  // look for ready
  pollLDRts();
}


/*
 * Link between PO and P2
 * LDR between P0 and GND
 * 
 * Use Stickstion to detect change of light level
 * 
 * sensor = 1 if moved into dark
 * sensor = 0 if moves into light.
 * 
 */
 
void setup() {
  // don't need to set anything up to use DigiKeyboard
  pinMode(0, INPUT_PULLUP); //LED on Model B
  pinMode(1, INPUT_PULLUP); //LED on Model A   
  
  //pinMode(2, INPUT_PULLUP); //LED on Model A   
  // INIT To force DARK CIRCLE
  // 
  pollLDRts();
  sensor   = BRIGHT;
}


/* look for Black Circle */

/*
 */

void loop() {
  // this is generally not necessary but with some older systems it seems to
  // prevent missing the first character after a delay:
  // Also Keycode 0 is release
  DigiKeyboard.sendKeyStroke(0);

  //DigiKeyboard.println("Hello This is Digispark! ");
  //DigiKeyboard.delay(random( 100, 350) );

  /* Turn on LED */
  pinMode(1, OUTPUT );
  //digitalWrite(1,HIGH );
  DigiKeyboard.delay( random( 100, 350) );
  digitalWrite(1,LOW );

    // digitalWrite(1,LOW );  
  pollLDRts();
  //typeAtoD();

  // Look for DARK CIRCLE to see if IDLE 
  if ( sensor == BRIGHT ){   
    digitalWrite( 1, HIGH );
    // DigiKeyboard.print( " AtoD:" );
    // DigiKeyboard.print( val );

    if ( random( 0, 100 ) > 100 ){
      xaws999selectTO();
      //DigiKeyboard.print( "==relinquish=");
      xaws999relinquish();
    } else {
      // Bright
      xaws999selectTO();
      xaws999selectToBackspace();      
      DigiKeyboard.print( "0292021001"); // Line that answers the call
      DigiKeyboard.delay( random( 100, 750) );
      
      // Press F5 wait for ANS then F5
      xaws999extend();
      DigiKeyboard.delay( random( 1000, 3000 ) );
      // Has call beed Answered?
      pollLDRts();

      // Select To and append last digit
      xaws999selectTO();
      DigiKeyboard.print( "7"); // Line that answers the call
      
      DigiKeyboard.delay( random( 500, 750 ) );
      DigiKeyboard.sendKeyStroke( KEY_F5 );
      DigiKeyboard.delay( random( 1000, 2000 ) );

      // has call been Answered
      pollLDRts();
      //
      // Call has not gone
      //
      if ( sensor == BRIGHT ){   
        DigiKeyboard.sendKeyStroke( KEY_F5 );
        DigiKeyboard.delay( random( 1000, 2000 ) );
      }
      // Call has not gone
      //
      if ( sensor == BRIGHT ){   
        DigiKeyboard.sendKeyStroke( KEY_F5 );
        DigiKeyboard.delay( random( 1000, 2000 ) );
      }
            
      // has call been Answered
      pollLDRts();
      //
      // Call has not gone
      //
      if ( sensor == BRIGHT ){   
        xaws999relinquish();
        /*
         * 
         */
      }   
      if ( sensor == BRIGHT ){   
        xaws999relinquish();
        /*
         * 
         */
      }   

    
    }
  } else {
    
    // digitalWrite(1,LOW );
    // xaws999relinquish();
    pollLDRts();
    //DigiKeyboard.sendKeyStroke( KEY_TAB, MOD_ALT_LEFT );
    //DigiKeyboard.delay(random( 100, 750) );
    //sendKeyStroke: sends a key press AND release with modifiers
    DigiKeyboard.sendKeyPress( KEY_TAB, MOD_ALT_LEFT );
    DigiKeyboard.delay(random( 400, 750) );
    // Has tab menu been displayed, has LDR changed?
    pollLDRts();
    // Has tab menu been displayed
    DigiKeyboard.delay(random( 400, 750) );
    DigiKeyboard.sendKeyPress( 0, 0 );
    DigiKeyboard.delay(random( 400, 750) );
    // Are we back at Black Dot? Has tab menu been displayed, has LDR changed?
    pollLDRts();
    DigiKeyboard.sendKeyPress( 0, 0 );
    DigiKeyboard.delay(random( 400, 750) );
    // Are we back at Black Dot? Has tab menu been displayed, has LDR changed?
    pollLDRts();
    if ( sensor == BRIGHT ){   
      pollLDRts();
      DigiKeyboard.sendKeyPress( 0, 0 );
      DigiKeyboard.delay(random( 400, 750) );
      // Are we back at Black Dot? Has tab menu been displayed, has LDR changed?
    }
    pollLDRts();
    if ( sensor == BRIGHT ){   
      pollLDRts();
      DigiKeyboard.sendKeyPress( 0, 0 );
      DigiKeyboard.delay(random( 400, 750) );
      // Are we back at Black Dot? Has tab menu been displayed, has LDR changed?
    }    
  }
}
/*
  sendKeyPress(keyStroke, modifiers);
    // This stops endlessly repeating keystrokes:
  sendKeyPress(0,0);
*/  


   /* 
    *  ALT tab brings up TAB menu which affect s LDR
    *  
    *  The menu displayed when ALT-TAB pressed - can be detected by the LDR
    *  The menu goes when ALT released - can be detected by the LDR
    *  
    */
    
/*    
      xaws999selectTO();
      DigiKeyboard.print( "==DARK CIRCLE==");
      xaws999selectTO();
   
      DigiKeyboard.print( " AtoD:" );
      DigiKeyboard.print( val );
*/


/*
 * If A-leg Off hook F5 wait ANS F5 return to READY. check for ready.
 * If A-leg On hook F5 wait ANS F5 does not return to ready F12 can be used to clear B-leg
 * If A-leg On hook F5 wait ANS F5 does not return to ready F12 can be used to clear B-leg, relinquish the call.
 * 
 * If A-leg Off hook set To to 0292921001 F5 get to unobtainable and screen does not return to ready, wait ANS F5 return to READY
 * 
 * 
 */


/*
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 * 
 */
